"""
This module acts as a Baler server interface that runs the address_baler()
function in different modes.
The CLI or GUI must communicate with this interface to access the
and always listen for
the new incoming Baler devices. It automatically detects the new Baler and
assign a new specific ip address to it.
"""
import sys
import threading

from .baler import check_rp_filters_off, address_balers

# Signal to kill the thread.
stop_thread = False

# TODO: THIS MODULE IS NOT A REAL INTERFACE. MODIFY IT SO OTHER PACKAGES CAN
#  INTERACT WITH THIS INTERFACE.


def run_baler_server():
    """
    Run the server to automatically connect all Balers to the bline software.
    This is the automated
    """
    if not check_rp_filters_off():
        sys.exit(1)
    trd = threading.Thread(name='baler-server', target=address_balers,
                           args=(lambda: stop_thread,))
    trd.start()
    # address_balers()


def baler_server_shutdown():
    """
    Shutdown the Baler server.
    """
    global stop_thread
    stop_thread = True


def run_baler_non_server(tags):
    """
    Run the Baler in a non server mode.

    keyword arguments:
    tags -- (tuple) List of all Baler tags passed by user.
    """
    if not check_rp_filters_off():
        sys.exit(1)
    address_balers(lambda: False, tags)


def baler_disconnect_all():
    """
    Disconnect all connected Balers.
    """
    # TODO: NEEDS IMPLEMENTATION.

